
/*
 *  wmessage.app -- wmessage.h [header]
 *
 *  Copyright (c) 1999,2000 Craig Nellist <crn@ozemail.com.au>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include <X11/Xlib.h>

#include <wraster.h>

#include <WINGs/WINGs.h>

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <ctype.h>

#include <X11/keysym.h>

#include <WUtil.h>

#include "wconfig.h"

#define AUTHOR "crn@ozemail.com.au"

#define SOURCE_MOUSE	0
#define SOURCE_KEYB	1

#define FIXED_FONT "-*-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"

/* struct for message panel */
typedef struct messagePanel {
    WMWindow *win;		       /* window */
    WMButton *defBtn;		       /* default button */
    WMButton *altBtn;		       /* alternative button */
    WMButton *othBtn;		       /* other button */
    WMLabel *iLbl;		       /* icon label */
    WMLabel *tLbl;		       /* title label */
    WMLabel *mLbl;		       /* message label */
    WMScrollView *view;		       /* scroll view -- for showing files */
    WMFrame *line;		       /* separator */
    short result;		       /* button that was pushed */
    short done;

    KeyCode retKey;
    KeyCode entKey;
    KeyCode escKey;
} messagePanel;

typedef struct {
	Display *dpy;
	char *display_name;
	int timeout;
	int reload;
	WMHandlerID timerTimeout;
	WMHandlerID timerReload;
	int noicon;
	char *icon;
	int print;
	int centre;
	int nearmouse;
	int nokeys;
	int nobuttons;
	int nomouse;
	int warnings;
	int source;		/* keyboard or mouse */
	char *filename;
	int fixedfont;
	int emptyfile;
	int force;

	char *wintitle;
	char *title;
	char *prompt;
	char *def;
	char *alt;
	char *other;
} _settings;

_settings *settings;

void usage(void);
void check_args (int argc, char **argv);
void setAppIcon (WMScreen *scrPtr, char *path);

messagePanel * createPanel (WMScreen *scrPtr, _settings *settings);
int showPanel (WMScreen *scrPtr, _settings *settings);
void destroyPanel (messagePanel *panel);
